/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package it.tidalwave.openrdf.elmo.impl;

import it.tidalwave.openrdf.elmo.ElmoAsSupport;
import it.tidalwave.util.As;
import it.tidalwave.util.AsException;
import java.util.HashMap;
import java.util.Map;
import javax.annotation.Nonnull;

/**
 *
 * @author fritz
 */
public class ElmoAs implements As
  {
    @Nonnull
    private final Object owner;

    // This is flushed at each transaction boundary
    private Map<Class<?>, Object> asMap = new HashMap<Class<?>, Object>();

    /***************************************************************************
     *
     *
     **************************************************************************/
    public ElmoAs (@Nonnull final Object owner)
      {
        this.owner = owner;
      }
    
    /***************************************************************************
     *
     *
     **************************************************************************/
    @Nonnull
    public <T> T as (@Nonnull final Class<T> clazz)
      {
        return as(clazz, new NotFoundBehaviour<T>()
          {
            public T run (@Nonnull final Throwable t)
              {
                throw new AsException(clazz, t);
              }
          });
      }

    /***************************************************************************
     *
     *
     **************************************************************************/
    @Nonnull
    public <T> T as (@Nonnull final Class<T> clazz, @Nonnull final NotFoundBehaviour<T> notFoundBehaviour)
      {
        Object as = asMap.get(clazz);

        if (as != null)
          {
            return (T)as;
          }

        as = ElmoAsSupport.as(owner, clazz);
        asMap.put(clazz, as); // FIXME: should you cache the result from notFoundBehaviour?

        return (T)((as != null) ? as : notFoundBehaviour.run(null));
      }
  }
