/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package it.tidalwave.semantic;

import javax.annotation.CheckForNull;

/**
 *
 * @author fritz
 */
public abstract class LazyPropertyHolder<T>
  {
    @CheckForNull
    private T cached;

    private boolean resolved;

    @CheckForNull
    public final synchronized T get()
      {
        if (!resolved)
          {
            cached = create();
            resolved = true;
          }

        return cached;
      }

    @CheckForNull
    protected abstract T create();

    public synchronized void invalidate()
      {
        resolved = false;
        cached = null;
      }
  }
